import java.awt.*;
import objectdraw.*;

/* 
 * Data structure to store a collection of balls
 * Andrea Danyluk
 * March 2002
 * 
 * $Id: BallList.java 2230 2013-10-27 02:26:10Z terescoj $
 */
public class BallList {
    // the most recently added ball
    private FilledOval first;

    // the rest of the list
    private BallList rest;

    public BallList(FilledOval aBall, BallList theRest)
    {
        first = aBall;
        rest = theRest;
    }

    // pre:
    // post: returns true iff the list of balls is empty
    public boolean isEmpty()
    {
        return (first == null);
    }

    // pre:
    // post: animates the motion of the ball list
    public void react()
    {
        new ReactiveBallList(this, 10);
    }

    // pre:
    // post: returns first
    public FilledOval getFirst()
    {
        return first;
    }

    // pre:
    // post: returns rest
    public BallList getRest()
    {
        return rest;
    }


}