import java.awt.*;
import objectdraw.*;

/* 
 * Animator for a BallList
 * Andrea Danyluk
 * March 2002
 * 
 * Updated by Jim Teresco, The College of Saint Rose, Fall 2013
 * 
 * $Id: ReactiveBallList.java 2230 2013-10-27 02:26:10Z terescoj $
 */

public class ReactiveBallList extends ActiveObject {

    private static final int PAUSETIME = 20;
    private static final double SPEED = 1;

    // the list of balls to animate
    private BallList ballList;

    // distance that each ball should move
    private int distanceToMove;

    // the constructor here just remembers the BallList
    // and how much they're supposed to move, then
    // starts up the ActiveObject
    public ReactiveBallList (BallList aList, int distance) {
        ballList = aList;
        distanceToMove = distance;

        start();
    }

    // do our animation
    public void run() {
        FilledOval nextBall;
        double pixelsMoved;

        // process each ball in the list, animate each a bit
        // before moving on to the next
        while (!ballList.isEmpty()) {
            nextBall = ballList.getFirst();
            pixelsMoved = 0;
            while (pixelsMoved < distanceToMove) {
                nextBall.move(SPEED, 0);
                pause(PAUSETIME);
                pixelsMoved = pixelsMoved + SPEED;
            }
            ballList = ballList.getRest();
        }
    }
}